
#ifndef SCENE_H
#define SCENE_H

struct shmDB{
	int PickedUp;
	int imageWidth, imageHeight;
	pid_t lrtpid;
	pid_t viewerpid;
	float x, y;
	float r, g, b;
};

class Scene {
  public:

	Scene();

	void AddPrimitives(const vector < Primitive * >&prim);

	void Render();

	~Scene();

	bool Intersect(const Ray & ray, Float mint, Float * maxt,
				   HitInfo * hit) const;

	bool Unoccluded(const Point &, const Point &) const;
	bool Unoccluded(const Ray &) const;

	Camera *camera;
	Image *image;
	JitterSampler *sampler;

	RtToken IlluminationIntegrator;

  private:
	 Accelerator * accelerator;
	 vector < Primitive * >primitives;
};

#endif // SCENE_H
